package ids;

import javax.swing.*;
import ids.*;

public
class CommonSignature extends AnySignature{

    public String sig_source;       // shows wheather the signature comes from snort or dragon
    public String protected_network;// protected network ip

    public String description; 	    // signature description (cve references, and others)
    public String action;           // what should be done after
    public String protocol;	        // which protocol

    public String source_ip;        // source ip numbers
    public boolean source_ip_neg;   // if true then negate source_ips
    public String source_port;      // source port number of the packet
    public boolean source_port_neg;	// if true then negate source_port
    public String destination_ip;   // destination ip numbers
    public boolean destination_ip_neg;  // if true then negate destination_ips
    public String destination_port;	    // destination port of the packet
    public boolean destination_port_neg;// if true then negate destination_port
    public String direction;        // $External -> $Protected, Protected -> External, External <> Protected

    public String pattern;          // text, we are looking for
    public String pattern_type;	    // is it this text EXACTLY or something like this
    public boolean pattern_neg;	    // catch packet only with this or only without this text
    public String message;          // what mesage text should be send to You after alarm

    public String comment;          // additional comments for rule

    public int loged_packets;       // number of packet logged after alarm occurs
    public int search_depth = 0;    // how many bytes each packet should be checked
    public boolean success;
    public String result = "";

	public CommonSignature(String act, String prot, String sourc, String descr,
							String sip, boolean sipneg, String dip, boolean dipneg,
							String sp, boolean spneg, String dp, boolean dpneg,
							String patt, String patttype, boolean pattneg,
							String msg, int log_pack, int log_depth, String comm){

		action 		= act;
		protocol 	= prot;
		sig_source 	= sourc;
		description = descr;

		source_ip 		= sip;
		source_ip_neg 		= sipneg;
		destination_ip 	= dip;
		destination_ip_neg 	= dipneg;

		source_port = sp;
		source_port_neg = spneg;
		destination_port = dp;
		destination_port_neg = dpneg;

		pattern = patt;
		pattern_type = patttype;
		pattern_neg = pattneg;
		message = msg;

		loged_packets = log_pack;
		search_depth = log_depth;

		comment = comm;

		result = "CIDSS constructor: SUCCEED";
	}



	public CommonSignature(){}


	public String getDescribe(){
		String s = "";
		s += "\n----------------------------------------------------\n";
		s += "\nCIDSS Signature:\n";
		s += "\naction: " + action;
		s += "\nprotocol: " + protocol;
		s += "\nsignature source: " + sig_source;
		s += "\ndescription: " + description;

		s += "\nSource IP: " + source_ip;
		s += "\nSource IP negation: " + source_ip_neg;
		s += "\nSource port: " + source_port;
		s += "\nSource port negation: " + source_port_neg;

		s += "\nDestination IP: " + destination_ip;
		s += "\nDestination IP negation: " + destination_ip_neg;
		s += "\nDestination port: " + destination_port;
		s += "\nDestination port negation: " + destination_port_neg;

		s += "\nType of text we are looking for: " + pattern_type;
		s += "\nText we are looking for: " + pattern;
		s += "\nText negation?: " + pattern_neg;
		s += "\nMessage send after alarm: " + message;
		s += "\nNumber of packets logged: " + loged_packets;
		s += "\nSearch depth: " + search_depth;
		s += "\nAdditional informations: " + comment;
		s += "\n------------------------------------------------------\n";

		return s;
	}


	public void printToConsole(){
		System.out.println( getDescribe() );
	}

}
