package ids;

import java.util.regex.*;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

class RealSecureSignature extends AnySignature{
		private static int number;
		String action = "alert";
		String sig_source = "RealSecure";
		String description = "";
		int search_depth = 0;
		String pattern_type = "string";
		String pattern = "";
		String message = "";
		String comment = "";

		private String position = "main";
		public static int ruleEnabled = 1;
		public static String protocol = "";
		public static String sourceIP = "";
		public static String sourcePort = "";
		public static String sourceMask = "";
		public static String destIP = "";
		public static String destPort = "";
		public static String destMask = "";
		public static String shrt = "";
		public static int priority = 3;

		public String dispChoice = "Default";
		public int dispEnabled = 1;
		public String logChoice = "LogFiltred";
		public int logEnabled = 1;

		private static Pattern p;
		private static Matcher m;
		static boolean isConnection = false;

	    public static boolean success;
	    public static String result = "";

		public RealSecureSignature(String str){
			number++;
			position = "main";
			System.out.println("Creating new rule ("+number+")... from string:");
			System.out.println(str);
			readSignatureStr(str);
		}

	private void readSignatureStr(String str){
		BufferedReader br;
		String read = "";
		try {
			br = new BufferedReader(new StringReader(str));
			while((read = br.readLine())!=null){	//break when end of file reached
				parseLine(read);
			}
			br.close();
			result = "RealSecure constructor(str): SUCCEED";
      		success = true;
			return;
		}catch (IOException e) {
			result = "RealSecure constructor(str): FAILED - error parsing rule";
			System.out.println(result);
			success = false;
			return;
		}
	}

	private void parseLine(String s) {
//		System.out.println("Parsing line: "+s);
		p = Pattern.compile("^\\[\\\\template\\\\connections\\\\connection(\\d+)\\\\(.*)];");
		m = p.matcher(s);
		if(m.matches()) {
			if(m.group(2).equals("")) {
				if(isConnection) {
                  result = "RealSecure -> CIDSS: Only one rule can be translated";
                  success = false;
				}
                number = Integer.parseInt(m.group(1));
                position = "main";
			}
			if(m.group(2).equals("Response\\DISPLAY\\")) {
				setPosition("display");
			}
			if(m.group(2).equals("Response\\LOGDB\\")) {
				setPosition("logdb");
			}
			isConnection = true;
			return;
		} else if(isConnection) {
			connection(s);
			return;
		}
		p = Pattern.compile("^\\[\\\\template(.*)");
		m = p.matcher(s);
		if (m.matches()) {
			if(this!=null) {
				result = "RealSecure constructor: currently only 1 rule supported";
//				System.out.println(result);
				success = false;
				return;
			}
			isConnection = false;
		}
	}

	static void connection(String s) {
		p = Pattern.compile("^Enabled\\t=B\\t(0|1);");
		m = p.matcher(s);
		if (m.matches()) {
			ruleEnabled = Integer.parseInt(m.group(1));
			return;
		}
		p = Pattern.compile("^protocol\\t=S\\t(.*);");
		m = p.matcher(s);
		if (m.matches()) {
			protocol = m.group(1);
			return;
		}
		p = Pattern.compile("^source address\\t=S\\t(.*);");
		m = p.matcher(s);
		if (m.matches()) {
			sourceIP = m.group(1);
			return;
		}
		p = Pattern.compile("^source mask\\t=S\\t(.*);");
		m = p.matcher(s);
		if (m.matches()) {
			sourceMask = m.group(1);
			return;
		}
		p = Pattern.compile("^source port\\t=S\\t(.*);");
		m = p.matcher(s);
		if (m.matches()) {
			sourcePort = m.group(1);
			return;
		}
		p = Pattern.compile("^dest address\\t=S\\t(.*);");
		m = p.matcher(s);
		if (m.matches()) {
			destIP = m.group(1);
			return;
		}
		p = Pattern.compile("^dest mask\\t=S\\t(.*);");
		m = p.matcher(s);
		if (m.matches()) {
			destMask = m.group(1);
			return;
		}
		p = Pattern.compile("^dest port\\t=S\\t(.*);");
		m = p.matcher(s);
		if (m.matches()) {
			destPort = m.group(1);
			return;
		}
		p = Pattern.compile("^shrt\\t=S\\t(.*);");
		m = p.matcher(s);
		if (m.matches()) {
			shrt = m.group(1);
			return;
		}
		p = Pattern.compile("^priority\\t=S\\t(.*);");
		m = p.matcher(s);
		if (m.matches()) {
			priority = Integer.parseInt(m.group(1));
			return;
		}
	}
		public void setPosition(String pos) {
			position = pos;
		}

    public RealSecureSignature(CommonSignature cs) {
      action = cs.action;
      protocol = cs.protocol;
      sig_source = cs.sig_source;
      description = cs.description;
      sourceIP = cs.source_ip.equals("any")?"0.0.0.0":cs.source_ip;
      sourceMask = "0";            // fix this in common!
      sourcePort = cs.source_port.equals("any")?"0":cs.source_port;
      destIP = cs.destination_ip.equals("any")?"0.0.0.0":cs.destination_ip;
      destMask = "0";            // fix this in common!
      destPort = cs.destination_port.equals("any")?"0":cs.destination_port;
      pattern = "";
      pattern_type = "string";
//      pattern_neg = false        // fix this!
      message = "";
//      logged_packets = 0;        // fix
      search_depth = cs.search_depth;
      comment = cs.comment;
	  success = true;
    }

    /* fix this */
    public CommonSignature toCommon(){

		comment = "priority="+priority;

        result = "RealSecure -> toCommon(): SUCCEED";
        success = true;
        return new CommonSignature(action, protocol, sig_source, description,
                                    sourceIP+"/"+sourceMask, false, destIP+"/"+destMask, false,
                                    sourcePort,  false, destPort, false,
                                    pattern, pattern_type, false, message,
                                    0, search_depth, comment);

    }

    public String getDescribe(){
        String s = "";
        s += "\n----------------------------------------------------\n";
        s += "\nCIDSS Signature:\n";
        s += "\nprotocol: " + protocol;
        s += "\nsignature source: " + sig_source;
        s += "\ndescription: " + description;

        s += "\nSource IP: " + sourceIP;
        s += "\nSource IP Mask: " + sourceMask;
        s += "\nSource port: " + sourcePort;

        s += "\nDestination IP: " + destIP;
        s += "\nDestination IP Mask: " + destMask;
        s += "\nDestination port: " + destPort;

        s += "\nType of text we are looking for: " + pattern_type;
        s += "\nMessage send after alarm: " + message;
        s += "\nAdditional informations: " + comment;

        s += "\n------------------------------------------------------\n";

        return s;
    }



    public String getSignature(){

        String string = "";

		string += "[\\];\n";
		string += "[\\template\\];\n";
		string += "[\\template\\connections\\];\n";
		string += "[\\template\\connections\\connection0000\\];\n";
		string += "Enabled =B      "+ruleEnabled+";\n";
		string += "protocol        =S      "+protocol+";\n";
		string += "source address  =S      "+sourceIP+";\n";
		string += "source mask     =S      "+sourceMask+";\n";
		string += "source port     =S      "+sourcePort+";\n";
		string += "dest address    =S      "+destIP+";\n";
		string += "dest mask       =S      "+destMask+";\n";
		string += "dest port       =S      "+destPort+";\n";
		string += "shrt    =S      "+shrt+";\n";
		string += "Priority        =L      "+priority+";\n";
		string += "[\\template\\connections\\connection0000\\Response\\];\n";
		string += "[\\template\\connections\\connection0000\\Response\\DISPLAY\\];\n";
		string += "Choice  =S      "+dispChoice+";\n";
		string += "Enabled =B      "+dispEnabled+";\n";
		string += "[\\template\\connections\\connection0000\\Response\\LOGDB\\];\n";
		string += "Enabled =B      "+logEnabled+";\n";
		string += "Choice  =S      "+logChoice+";\n";

        return string;
    }
}
